
/***************************************************************************

                                 ChessV

                   COPYRIGHT (C) 2005 BY GREGORY STRONG

This file is part of ChessV.  ChessV is free software; you can redistribute
it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the License, 
or (at your option) any later version.

ChessV is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
more details; the file 'COPYING' contains the License text, but if for
some reason you need a copy, please write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/


#ifndef FILE__EVAL_HASHTABLE_H
#define FILE__EVAL_HASHTABLE_H


#include "EvalHash.h"


class EvalHashtable
{
  protected:
	//	data memebers
	Board &board;
	EvalHash *table;
	int tableSize;
	word32 hashMask;


  public:
	//	construction
	EvalHashtable( Board &theBoard, unsigned sizeInMB = 16 );


	//	destruction
	~EvalHashtable();

	
	//	operations
	void SetSize( unsigned long int newSize );

	void Store( int evaluation );

	bool Lookup( int &evaluation );

	void ClearAll();
};


#endif
