
/***************************************************************************

                                 ChessV

                   COPYRIGHT (C) 2005 BY GREGORY STRONG

This file is part of ChessV.  ChessV is free software; you can redistribute
it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the License, 
or (at your option) any later version.

ChessV is distributed in the hope that it will be useful, but WITHOUT ANY 
WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
more details; the file 'COPYING' contains the License text, but if for
some reason you need a copy, please write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/


#ifndef FILE__MOVE_INFO_H
#define FILE__MOVE_INFO_H


#include "Movement.h"


struct MoveInfo
{
  public:
	//	data members
	short pickupCursor;
	short dropCursor;
	MoveType type;
	short fromSquare;
	short toSquare;
	int evaluation;
	Piece *pPieceMoved;
	PieceType *promotion;
	PieceType *originalType;
	byte tag;
	byte filler;


	//	construction
	MoveInfo()
	{
	}


	//	operations
	bool operator==( const Movement &move ) const
	{
		return( type == move.GetMoveType() && 
				toSquare == move.GetToSquare() &&
				fromSquare == move.GetFromSquare() &&
				tag == move.GetTag() &&
				promotion == move.GetNewType() );
	}

	operator Movement() const;
};


#endif
